<?php

class rex_xform_select extends rex_xform_abstract
{

	/*
	 * Werte setzen
	 */
	function preAction()
	{
		foreach (explode(";", $this->elements[3]) as $v)
		{
			$teile = explode("=", $v);
			$wert = $teile[0];
			if (is_array($teile) && isset ($teile[1]))
			{
				$bezeichnung = $teile[1];
			}else
			{
				$bezeichnung = $teile[0];
			}
			$this->setKey($bezeichnung,$wert);
		}
	} 

	function enterObject(&$email_elements,&$sql_elements,&$warning,&$form_output,$send = 0)
	{
	
		$this->label = $this->elements[1];
		$multiple = FALSE;
		if(isset($this->elements[6]) && $this->elements[6]==1)
			$multiple = TRUE;
	
		$SEL = new rex_select();
		$SEL->setId("el_" . $this->id);
		if($multiple)
		{
			$SEL->setName("FORM[" . $this->params["form_name"] . "][el_" . $this->id . "][]");
			$SEL->setSize(5);
			$SEL->setMultiple(1);
			if(!is_array($this->value))
				$this->value = array();
		}else
		{
			$SEL->setName("FORM[" . $this->params["form_name"] . "][el_" . $this->id . "]");
			$SEL->setSize(1);
			$this->value = stripslashes($this->value);	}

		foreach($this->getKeys() as $k => $v)
		{
			$SEL->addOption($v, $k);
		}

		if ($this->value == "" && !$send)
		{
			if (isset($this->elements[5])) $SEL->setSelected($this->elements[5]);
		}else
		{
			if (is_array($this->value))
			{
				foreach($this->value as $val) $SEL->setSelected($val);
			}else
			{
				$SEL->setSelected($this->value);
			}
		}

		$wc = "";
		if (isset($warning["el_" . $this->getId()])) $wc = $warning["el_" . $this->getId()];
		$SEL->setStyle(' class="select ' . $wc . '"');

		$form_output[] = ' 
			<p class="formselect formlabel-'.$this->label.'">
			<label class="select ' . $wc . '" for="el_' . $this->id . '" >' . $this->elements[2] . '</label>' . 
			$SEL->get() . '
			</p>';

		$email_elements[$this->elements[1]] = $this->value;
		if (!isset($this->elements[4]) || $this->elements[4] != "no_db") $sql_elements[$this->elements[1]] = $this->value;

	}
	
	function getDescription()
	{
		return "select -> Beispiel: select|gender|Geschlecht *|Frau=w;Herr=m|[no_db]|defaultwert|multiple=1";
	}
}

?>